// AxisDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Axis.h"
#include "AxisDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAxisDlg dialog

CAxisDlg::CAxisDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAxisDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAxisDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAxisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAxisDlg)
	DDX_Control(pDX, IDC_EDIT_MINIMUM, m_EditMinimum);
	DDX_Control(pDX, IDC_EDIT_MAXIMUM, m_EditMaximum);
	DDX_Control(pDX, IDC_EDIT_CAPTION, m_EditCaption);
	DDX_Control(pDX, IDC_COMBO_AXIS, m_Axis);
	DDX_Control(pDX, IDC_CHECK_TICKS_OUTSIDE, m_CheckTicksOutside);
	DDX_Control(pDX, IDC_CHECK_TICKS_OPPOSITE, m_CheckTicksOpposite);
	DDX_Control(pDX, IDC_CHECK_TICKS_NORMAL, m_CheckTicksNormal);
	DDX_Control(pDX, IDC_CHECK_TICKS_MINOR, m_CheckTicksMinor);
	DDX_Control(pDX, IDC_CHECK_TICKS_MAJOR, m_CheckTicksMajor);
	DDX_Control(pDX, IDC_CHECK_TICKS_INSIDE, m_CheckTicksInside);
	DDX_Control(pDX, IDC_CHECK_LABELS_NORMAL, m_CheckLabelsNormal);
	DDX_Control(pDX, IDC_CHECK_LOG, m_Log);
	DDX_Control(pDX, IDC_CHECK_INVERTED, m_Inverted);
	DDX_Control(pDX, IDC_CHECK_GRID_MINOR, m_CheckGridMinor);
	DDX_Control(pDX, IDC_CHECK_GRID_MAJOR, m_CheckGridMajor);
	DDX_Control(pDX, IDC_CHECK_CAPTION_OPPOSITE, m_CheckCaptionOpposite);
	DDX_Control(pDX, IDC_CHECK_CAPTION_NORMAL, m_CheckCaptionNormal);
	DDX_Control(pDX, IDC_CHECK_AUTOSCALE_PLOT, m_CheckAutoScalePlot);
	DDX_Control(pDX, IDC_CHECK_AUTOSCALE, m_AutoScale);
	DDX_Control(pDX, IDC_CHECK_LABELS_OPPOSITE, m_CheckLabelsOpposite);
	DDX_Control(pDX, IDC_CWGRAPH3D1, m_graph);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAxisDlg, CDialog)
	//{{AFX_MSG_MAP(CAxisDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_AUTOSCALE_NOW, OnButtonAutoscaleNow)
	ON_BN_CLICKED(IDC_BUTTON_GENERATE_PLOT, OnButtonGeneratePlot)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_PLOT, OnButtonRemovePlot)
	ON_BN_CLICKED(IDC_BUTTON_SET_MAX, OnButtonSetMax)
	ON_BN_CLICKED(IDC_BUTTON_SET_MIN, OnButtonSetMin)
	ON_BN_CLICKED(IDC_CHECK_AUTOSCALE, OnCheckAutoscale)
	ON_BN_CLICKED(IDC_CHECK_AUTOSCALE_PLOT, OnCheckAutoscalePlot)
	ON_BN_CLICKED(IDC_CHECK_CAPTION_NORMAL, OnCheckCaptionNormal)
	ON_BN_CLICKED(IDC_CHECK_CAPTION_OPPOSITE, OnCheckCaptionOpposite)
	ON_BN_CLICKED(IDC_CHECK_GRID_MAJOR, OnCheckGridMajor)
	ON_BN_CLICKED(IDC_CHECK_GRID_MINOR, OnCheckGridMinor)
	ON_BN_CLICKED(IDC_CHECK_INVERTED, OnCheckInverted)
	ON_BN_CLICKED(IDC_CHECK_LABELS_NORMAL, OnCheckLabelsNormal)
	ON_BN_CLICKED(IDC_CHECK_LABELS_OPPOSITE, OnCheckLabelsOpposite)
	ON_BN_CLICKED(IDC_CHECK_LOG, OnCheckLog)
	ON_BN_CLICKED(IDC_CHECK_TICKS_INSIDE, OnCheckTicksInside)
	ON_BN_CLICKED(IDC_CHECK_TICKS_MAJOR, OnCheckTicksMajor)
	ON_BN_CLICKED(IDC_CHECK_TICKS_MINOR, OnCheckTicksMinor)
	ON_BN_CLICKED(IDC_CHECK_TICKS_NORMAL, OnCheckTicksNormal)
	ON_BN_CLICKED(IDC_CHECK_TICKS_OPPOSITE, OnCheckTicksOpposite)
	ON_BN_CLICKED(IDC_CHECK_TICKS_OUTSIDE, OnCheckTicksOutside)
	ON_CBN_SELCHANGE(IDC_COMBO_AXIS, OnSelchangeComboAxis)
	ON_EN_CHANGE(IDC_EDIT_CAPTION, OnChangeEditCaption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAxisDlg message handlers

BOOL CAxisDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	m_Axis.SetCurSel(0);
	m_Axis3D = m_graph.GetAxes().Item(1);
	RefreshControls();
	m_CheckAutoScalePlot.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAxisDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAxisDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//////////////////////////////////////////////////////////////////////////////
//	Control Callbacks
//////////////////////////////////////////////////////////////////////////////

void CAxisDlg::OnButtonAutoscaleNow() 
{
	m_Axis3D.AutoScaleNow();
	RefreshControls();
}

#define PI 3.1415926535

void CAxisDlg::OnButtonGeneratePlot() 
{
	// Generate data
	double t[41];
	CNiReal64Matrix xData(41,41);
	CNiReal64Matrix yData(41,41);
	CNiReal64Matrix zData(41,41);
	int i, j;
	for (i = 0; i < 41; i++)
		t[i] = (i - 20.0)/20.0 * PI;
	for (i = 0; i < 41; i++)
		for (j = 0; j < 41; j++) 
		{
			xData(j, i) = (cos(t[j]) + 3.0) * cos(t[i]);
			yData(j, i) = (cos(t[j]) + 3.0) * sin(t[i]);
			zData(j, i) = sin(t[j]);
		}

	// Plot the data
	m_graph.Plot3DParametricSurface(xData, yData, zData);

	// Enable AutoScale plot check box
	m_CheckAutoScalePlot.EnableWindow(TRUE);

	// Refresh the controls
	RefreshControls();
}

void CAxisDlg::OnButtonRemovePlot() 
{
	// Disable AutoScale plot check box
	m_CheckAutoScalePlot.EnableWindow(FALSE);

	// Remove all the plots
	m_graph.GetPlots().RemoveAll();

	// Refresh the controls
	RefreshControls();
}

void CAxisDlg::OnButtonSetMax() 
{
	CString string;
	double maximum;
	m_EditMaximum.GetWindowText(string);
	maximum=atof(string);
	m_Axis3D.SetMaximum(maximum);
	RefreshControls();
}

void CAxisDlg::OnButtonSetMin() 
{
	CString string;
	double minimum;

	m_EditMinimum.GetWindowText(string);
	minimum=atof(string);
	m_Axis3D.SetMinimum(minimum);
	RefreshControls();
}

void CAxisDlg::OnCheckAutoscale() 
{
    m_Axis3D.SetAutoScale(m_AutoScale.GetCheck() ? true : false);
	RefreshControls();
}

void CAxisDlg::OnCheckAutoscalePlot() 
{
	m_graph.GetPlots().Item(1).SetAutoScale(m_CheckAutoScalePlot.GetCheck() ? true : false);
	RefreshControls();
}

void CAxisDlg::OnCheckCaptionNormal() 
{
	m_Axis3D.SetCaptionNormal(m_CheckCaptionNormal.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckCaptionOpposite() 
{
	m_Axis3D.SetCaptionOpposite(m_CheckCaptionOpposite.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckGridMajor() 
{
	m_Axis3D.GetTicks().SetMajorGrid(m_CheckGridMajor.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckGridMinor() 
{
	m_Axis3D.GetTicks().SetMinorGrid(m_CheckGridMinor.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckInverted() 
{
	m_Axis3D.SetInverted(m_Inverted.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckLabelsNormal() 
{
	m_Axis3D.GetLabels().SetNormal(m_CheckLabelsNormal.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckLabelsOpposite() 
{
	m_Axis3D.GetLabels().SetOpposite(m_CheckLabelsOpposite.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckLog() 
{
	m_Axis3D.SetLog(m_Log.GetCheck() ? true : false);
	RefreshControls();
}

void CAxisDlg::OnCheckTicksInside() 
{
	m_Axis3D.GetTicks().SetInside(m_CheckTicksInside.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckTicksMajor() 
{
	m_Axis3D.GetTicks().SetMajorTicks(m_CheckTicksMajor.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckTicksMinor() 
{
	m_Axis3D.GetTicks().SetMinorTicks(m_CheckTicksMinor.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckTicksNormal() 
{
	m_Axis3D.GetTicks().SetNormal(m_CheckTicksNormal.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckTicksOpposite() 
{
	m_Axis3D.GetTicks().SetOpposite(m_CheckTicksOpposite.GetCheck() ? true : false);
}

void CAxisDlg::OnCheckTicksOutside() 
{
	m_Axis3D.GetTicks().SetOutside(m_CheckTicksOutside.GetCheck() ? true : false);
}

void CAxisDlg::OnSelchangeComboAxis() 
{
	if (m_Axis.GetCurSel() == 0)
		m_Axis3D = m_graph.GetAxes().Item(1);
	else if (m_Axis.GetCurSel() == 1)
		m_Axis3D = m_graph.GetAxes().Item(2);
	else if (m_Axis.GetCurSel() == 2)
		m_Axis3D = m_graph.GetAxes().Item(3);
	else
		return;
	RefreshControls();
}

void CAxisDlg::OnChangeEditCaption() 
{
	CString string;
	m_EditCaption.GetWindowText(string);
	m_Axis3D.SetCaption(string);
}



//////////////////////////////////////////////////////////////////////////////
//	RefreshControls
//////////////////////////////////////////////////////////////////////////////

void CAxisDlg::RefreshControls() 
{
	// Autoscale Plot
	if (m_graph.GetPlots().GetCount() > 0)
		m_CheckAutoScalePlot.SetCheck(m_graph.GetPlots().Item(1).GetAutoScale());
	// Autoscale
	m_AutoScale.SetCheck(m_Axis3D.GetAutoScale());
	
	// Minimum
	CString string;
	double minimum=m_Axis3D.GetMinimum();
	string.Format("%lf", minimum);
	m_EditMinimum.SetWindowText(string);
	
	// Maximum
	double maximum=m_Axis3D.GetMaximum();
	string.Format("%lf", maximum);
	m_EditMaximum.SetWindowText(string);
	
	// Inverted
	m_Inverted.SetCheck(m_Axis3D.GetInverted());
	// Log
	m_Log.SetCheck(m_Axis3D.GetLog());
	// Caption
	m_EditCaption.SetWindowText(m_Axis3D.GetCaption());
	// CaptionNormal
	m_CheckCaptionNormal.SetCheck(m_Axis3D.GetCaptionNormal());
	// CaptionOpposite
	m_CheckCaptionOpposite.SetCheck(m_Axis3D.GetCaptionOpposite());
	// LabelsNormal
	m_CheckLabelsNormal.SetCheck(m_Axis3D.GetLabels().GetNormal());
	// LabelsOpposite
	m_CheckLabelsOpposite.SetCheck(m_Axis3D.GetLabels().GetOpposite());
	// TicksNormal
	m_CheckTicksNormal.SetCheck(m_Axis3D.GetTicks().GetNormal());
	// TicksOpposite
	m_CheckTicksOpposite.SetCheck(m_Axis3D.GetTicks().GetOpposite());
	// TicksInside
	m_CheckTicksInside.SetCheck(m_Axis3D.GetTicks().GetInside());
	// TicksOutside
	m_CheckTicksOutside.SetCheck(m_Axis3D.GetTicks().GetOutside());
	// TicksMajor
	m_CheckTicksMajor.SetCheck(m_Axis3D.GetTicks().GetMajorTicks());
	// TicksMinor
	m_CheckTicksMinor.SetCheck(m_Axis3D.GetTicks().GetMinorTicks());
	// GridMajor
	m_CheckGridMajor.SetCheck(m_Axis3D.GetTicks().GetMajorGrid());
	// GridMinor
	m_CheckGridMinor.SetCheck(m_Axis3D.GetTicks().GetMinorGrid());
}

