// ColorMapStylesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ColorMapStyles.h"
#include "ColorMapStylesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SIZE 41
#define NUM_CUSTOM_COLORS 5

/////////////////////////////////////////////////////////////////////////////
// CColorMapStylesDlg dialog

CColorMapStylesDlg::CColorMapStylesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorMapStylesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorMapStylesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CColorMapStylesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorMapStylesDlg)
	DDX_Control(pDX, IDC_CUSTOM_COLOR5, m_CustomColor5);
	DDX_Control(pDX, IDC_CUSTOM_COLOR4, m_CustomColor4);
	DDX_Control(pDX, IDC_CUSTOM_COLOR3, m_CustomColor3);
	DDX_Control(pDX, IDC_CUSTOM_COLOR2, m_CustomColor2);
	DDX_Control(pDX, IDC_CUSTOM_COLOR1, m_CustomColor1);
	DDX_Control(pDX, IDC_GRAPH_SURFACE, m_GraphSurface);
	DDX_Control(pDX, IDC_MAP_LOG, m_MapLog);
	DDX_Control(pDX, IDC_MAP_INTERPOLATE, m_MapInterpolate);
	DDX_Control(pDX, IDC_MAP_AUTO_SCALE, m_MapAutoScale);
    DDX_Control(pDX, IDC_STYLE_NONE, m_StyleNone);
    DDX_Control(pDX, IDC_STYLE_SHADED, m_StyleShaded);
    DDX_Control(pDX, IDC_STYLE_COLOR_SPECTRUM, m_StyleColorSpectrum);
    DDX_Control(pDX, IDC_STYLE_GRAY_SCALE, m_StyleGrayScale);
    DDX_Control(pDX, IDC_STYLE_CUSTOM, m_StyleCustom);
	DDX_Control(pDX, IDC_GRAPH, m_Graph3D);
	DDX_Control(pDX, IDC_CUSTOM_COLOR_INDICATOR1, m_CustomColorIndicator1);
	DDX_Control(pDX, IDC_CUSTOM_COLOR_INDICATOR2, m_CustomColorIndicator2);
	DDX_Control(pDX, IDC_CUSTOM_COLOR_INDICATOR3, m_CustomColorIndicator3);
	DDX_Control(pDX, IDC_CUSTOM_COLOR_INDICATOR4, m_CustomColorIndicator4);
	DDX_Control(pDX, IDC_CUSTOM_COLOR_INDICATOR5, m_CustomColorIndicator5);
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CColorMapStylesDlg, CDialog)
	//{{AFX_MSG_MAP(CColorMapStylesDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLOT_DUAL_SINE_SURFACE, OnPlotDualSineSurface)
	ON_BN_CLICKED(IDC_PLOT_TORUS, OnPlotTorus)
	ON_BN_CLICKED(IDC_MAP_AUTO_SCALE, OnMapAutoScale)
	ON_BN_CLICKED(IDC_MAP_INTERPOLATE, OnMapInterpolate)
	ON_BN_CLICKED(IDC_MAP_LOG, OnMapLog)
	ON_BN_CLICKED(IDC_STYLE_NONE, OnStyleNone)
	ON_BN_CLICKED(IDC_STYLE_SHADED, OnStyleShaded)
	ON_BN_CLICKED(IDC_STYLE_COLOR_SPECTRUM, OnStyleColorSpectrum)
	ON_BN_CLICKED(IDC_STYLE_GRAY_SCALE, OnStyleGrayScale)
	ON_BN_CLICKED(IDC_STYLE_CUSTOM, OnStyleCustom)
	ON_BN_CLICKED(IDC_GRAPH_SURFACE, OnGraphSurface)
	ON_BN_CLICKED(IDC_CUSTOM_COLOR1, OnCustomColor1)
	ON_BN_CLICKED(IDC_CUSTOM_COLOR2, OnCustomColor2)
	ON_BN_CLICKED(IDC_CUSTOM_COLOR3, OnCustomColor3)
	ON_BN_CLICKED(IDC_CUSTOM_COLOR4, OnCustomColor4)
	ON_BN_CLICKED(IDC_CUSTOM_COLOR5, OnCustomColor5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorMapStylesDlg message handlers

BOOL CColorMapStylesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    CNiPlot3D plot = m_Graph3D.Plots.Item(1);
    plot.Style = CNiPlot3D::HiddenLine;

    plot.ColorMapAutoScale = false;
    plot.ColorMapInterpolate = true;
    plot.ColorMapLog = false;

    plot.ColorMapStyle = CNiPlot3D::ColorSpectrum;

    RefreshControls();
    OnPlotDualSineSurface();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CColorMapStylesDlg::RefreshControls()
{
    CNiPlot3D plot = m_Graph3D.Plots.Item(1);
    m_GraphSurface.SetCheck(plot.Style == CNiPlot3D::Surface);

    m_MapAutoScale.SetCheck(plot.ColorMapAutoScale ? 1 : 0);
    if (plot.ColorMapInterpolate)
    {
        m_MapInterpolate.SetCheck(1);
        m_MapLog.EnableWindow();
    }
    else
    {
        m_MapInterpolate.SetCheck(0);
        m_MapLog.EnableWindow(FALSE);
    }
    m_MapLog.SetCheck((plot.ColorMapLog && plot.ColorMapInterpolate) ? 1 : 0);

    CNiPlot3D::ColorMapStyles style = plot.ColorMapStyle;
    if (style == CNiPlot3D::None)
        m_StyleNone.SetCheck(1);
    else if (style == CNiPlot3D::Shaded)
        m_StyleShaded.SetCheck(1);
    else if (style == CNiPlot3D::ColorSpectrum)
        m_StyleColorSpectrum.SetCheck(1);
    else if (style == CNiPlot3D::GrayScale)
        m_StyleGrayScale.SetCheck(1);
    else if (style == CNiPlot3D::Custom)
        m_StyleCustom.SetCheck(1);

    RefreshCustomControls();
}

void CColorMapStylesDlg::RefreshCustomControls()
{
    bool customEnabled = (m_Graph3D.Plots.Item(1).ColorMapStyle == CNiPlot3D::Custom);
    m_CustomColor1.EnableWindow(customEnabled);
    m_CustomColor2.EnableWindow(customEnabled);
    m_CustomColor3.EnableWindow(customEnabled);
    m_CustomColor4.EnableWindow(customEnabled);
    m_CustomColor5.EnableWindow(customEnabled);

    m_CustomColorIndicator1.Enabled = customEnabled;
    m_CustomColorIndicator2.Enabled = customEnabled;
    m_CustomColorIndicator3.Enabled = customEnabled;
    m_CustomColorIndicator4.Enabled = customEnabled;
    m_CustomColorIndicator5.Enabled = customEnabled;
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CColorMapStylesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CColorMapStylesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CColorMapStylesDlg::OnPlotDualSineSurface() 
{
	CNiReal64Vector xData(SIZE);
    CNiReal64Vector yData(SIZE);
    CNiReal64Matrix zData(SIZE, SIZE);
    int i, j;

    for (i = 0; i < SIZE; ++i)
        xData[i] = yData[i] = ((i - 20.0) / 20.0) * CNiMath::Pi;

    for (i = 0; i < SIZE; ++i)
    {
        for (j = 0; j < SIZE; ++j)
            zData(j, i) = sin(xData[i]) * cos(yData[j]) + 2.0;
    }

    m_Graph3D.Plot3DSurface(xData, yData, zData);
    if (m_Graph3D.Plots.Item(1).ColorMapStyle == CNiPlot3D::Custom)
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnPlotTorus() 
{
    double t[SIZE];
    CNiReal64Matrix xData(SIZE, SIZE);
    CNiReal64Matrix yData(SIZE, SIZE);
    CNiReal64Matrix zData(SIZE, SIZE);
    int i, j;

    for (i = 0; i < SIZE; ++i)
        t[i] = ((i - 20.0) / 20.0) * CNiMath::Pi;

    for (i = 0; i < SIZE; ++i)
    {
        for (j = 0; j < SIZE; ++j)
        {
            xData((SIZE - 1) - j, i) = (cos(t[j]) + 3.0) * cos(t[i]);
            yData((SIZE - 1) - j, i) = (cos(t[j]) + 3.0) * sin(t[i]);
            zData((SIZE - 1) - j, i) = sin(t[j]) + 2.0;
        }
    }

    m_Graph3D.Plot3DParametricSurface(xData, yData, zData);
    if (m_Graph3D.Plots.Item(1).ColorMapStyle == CNiPlot3D::Custom)
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnMapAutoScale() 
{
    m_Graph3D.Plots.Item(1).ColorMapAutoScale = (m_MapAutoScale.GetCheck() == 1);
}

void CColorMapStylesDlg::OnMapInterpolate()
{
    CNiPlot3D plot = m_Graph3D.Plots.Item(1);

    if (m_MapInterpolate.GetCheck() == 1)
    {
        plot.ColorMapInterpolate = true;
        m_MapLog.EnableWindow();
    }
    else
    {
        plot.ColorMapLog = false;
        plot.ColorMapInterpolate = false;
        m_MapLog.SetCheck(0);
        m_MapLog.EnableWindow(FALSE);
    }
}

void CColorMapStylesDlg::OnMapLog() 
{
    try
    {
        m_Graph3D.Plots.Item(1).ColorMapLog = (m_MapLog.GetCheck() == 1);
    }
    catch (CException* e)
    {
        m_MapLog.SetCheck(0);
        e->ReportError();
        e->Delete();
    }
}

void CColorMapStylesDlg::OnStyleNone() 
{
    m_Graph3D.Plots.Item(1).ColorMapStyle = CNiPlot3D::None;
    RefreshCustomControls();
}

void CColorMapStylesDlg::OnStyleShaded() 
{
    m_Graph3D.Plots.Item(1).ColorMapStyle = CNiPlot3D::Shaded;
    RefreshCustomControls();
}

void CColorMapStylesDlg::OnStyleColorSpectrum() 
{
    m_Graph3D.Plots.Item(1).ColorMapStyle = CNiPlot3D::ColorSpectrum;
    RefreshCustomControls();
}

void CColorMapStylesDlg::OnStyleGrayScale() 
{
    m_Graph3D.Plots.Item(1).ColorMapStyle = CNiPlot3D::GrayScale;
    RefreshCustomControls();
}

void CColorMapStylesDlg::OnStyleCustom() 
{
    m_Graph3D.Plots.Item(1).ColorMapStyle = CNiPlot3D::Custom;
    RefreshCustomControls();
    SetCustomColorMap();
}

void CColorMapStylesDlg::OnGraphSurface() 
{
    if (m_GraphSurface.GetCheck() == 1)	
        m_Graph3D.Plots.Item(1).Style = CNiPlot3D::Surface;
    else
        m_Graph3D.Plots.Item(1).Style = CNiPlot3D::HiddenLine;
}

bool CColorMapStylesDlg::SelectCustomColor(CNiButton& button)
{
    bool newColorPicked = false;

    CNiColor oldColor = button.OffColor;
    CColorDialog colorDialog(RGB(oldColor.Red, oldColor.Green, oldColor.Blue), CC_FULLOPEN);
    if (colorDialog.DoModal() == IDOK)
    {
        button.OffColor = colorDialog.GetColor();
        newColorPicked = true;
    }

    return newColorPicked;
}

void CColorMapStylesDlg::SetCustomColorMap()
{
    CNiPlot3D plot = m_Graph3D.Plots.Item(1);
    CNiAxis3D axis = plot.ZAxis;
    double interval = (axis.Maximum - axis.Minimum) / NUM_CUSTOM_COLORS;

    CNiReal64Vector mapValues(NUM_CUSTOM_COLORS);
    for (int i = 0; i < NUM_CUSTOM_COLORS; ++i)
        mapValues[i] = axis.Minimum + (i * interval);

    CNiColorVector mapColors(NUM_CUSTOM_COLORS);
    mapColors[0] = m_CustomColorIndicator5.OffColor;
    mapColors[1] = m_CustomColorIndicator4.OffColor;
    mapColors[2] = m_CustomColorIndicator3.OffColor;
    mapColors[3] = m_CustomColorIndicator2.OffColor;
    mapColors[4] = m_CustomColorIndicator1.OffColor;

    plot.ColorMapValues = mapValues;
    plot.ColorMapColors = mapColors;
}

void CColorMapStylesDlg::OnCustomColor1() 
{
    if (SelectCustomColor(m_CustomColorIndicator1))
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnCustomColor2() 
{
    if (SelectCustomColor(m_CustomColorIndicator2))
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnCustomColor3() 
{
    if (SelectCustomColor(m_CustomColorIndicator3))
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnCustomColor4() 
{
    if (SelectCustomColor(m_CustomColorIndicator4))
        SetCustomColorMap();
}

void CColorMapStylesDlg::OnCustomColor5() 
{
    if (SelectCustomColor(m_CustomColorIndicator5))
        SetCustomColorMap();
}   
