// ColorMapStylesDlg.h : header file
//
//{{AFX_INCLUDES()
#include "NiGraph3D.h"
#include "NiButton.h"
#include "NiSlide.h"
//}}AFX_INCLUDES

#if !defined(AFX_COLORMAPSTYLESDLG_H__4FCED974_BA80_443F_AE98_78CDB4FDEB92__INCLUDED_)
#define AFX_COLORMAPSTYLESDLG_H__4FCED974_BA80_443F_AE98_78CDB4FDEB92__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CColorMapStylesDlg dialog

class CColorMapStylesDlg : public CDialog
{
// Construction
public:
	CColorMapStylesDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CColorMapStylesDlg)
	enum { IDD = IDD_COLORMAPSTYLES_DIALOG };
	CButton	m_CustomColor5;
	CButton	m_CustomColor4;
	CButton	m_CustomColor3;
	CButton	m_CustomColor2;
	CButton	m_CustomColor1;
	CButton	m_GraphSurface;
	CButton	m_MapLog;
	CButton	m_MapInterpolate;
	CButton	m_MapAutoScale;
    CButton m_StyleNone;
    CButton m_StyleShaded;
    CButton m_StyleColorSpectrum;
    CButton m_StyleGrayScale;
    CButton m_StyleCustom;
	CNiGraph3D	m_Graph3D;
	CNiButton	m_CustomColorIndicator1;
	CNiButton	m_CustomColorIndicator2;
	CNiButton	m_CustomColorIndicator3;
	CNiButton	m_CustomColorIndicator4;
	CNiButton	m_CustomColorIndicator5;
	CNiSlide	m_CustomMapValues;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColorMapStylesDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
    void RefreshControls();
    void RefreshCustomControls();
    bool SelectCustomColor(CNiButton& button);
    void SetCustomColorMap();

	// Generated message map functions
	//{{AFX_MSG(CColorMapStylesDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPlotDualSineSurface();
	afx_msg void OnPlotTorus();
	afx_msg void OnMapAutoScale();
	afx_msg void OnMapInterpolate();
	afx_msg void OnMapLog();
	afx_msg void OnStyleNone();
	afx_msg void OnStyleShaded();
	afx_msg void OnStyleColorSpectrum();
	afx_msg void OnStyleGrayScale();
	afx_msg void OnStyleCustom();
	afx_msg void OnGraphSurface();
	afx_msg void OnCustomColor1();
	afx_msg void OnCustomColor2();
	afx_msg void OnCustomColor3();
	afx_msg void OnCustomColor4();
	afx_msg void OnCustomColor5();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLORMAPSTYLESDLG_H__4FCED974_BA80_443F_AE98_78CDB4FDEB92__INCLUDED_)
