// ContoursDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Contours.h"
#include "ContoursDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContoursDlg dialog

CContoursDlg::CContoursDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContoursDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContoursDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CContoursDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContoursDlg)
	DDX_Control(pDX, IDC_RADIO_LEVELS, m_RadioLevels);
	DDX_Control(pDX, IDC_EDIT_LEVELS, m_EditLevels);
	DDX_Control(pDX, IDC_EDIT_LABEL_FORMAT, m_EditLabelFormat);
	DDX_Control(pDX, IDC_EDIT_INTERVAL, m_EditInterval);
	DDX_Control(pDX, IDC_EDIT_ANCHOR, m_EditAnchor);
	DDX_Control(pDX, IDC_COMBO_LINE_STYLE, m_ComboLineStyle);
	DDX_Control(pDX, IDC_COMBO_LINE_COLOR, m_ComboLineColor);
	DDX_Control(pDX, IDC_COMBO_LABEL_COLOR, m_ComboLabelColor);
	DDX_Control(pDX, IDC_CHECK_LABELS_VISIBLE, m_CheckLabelsVisible);
	DDX_Control(pDX, IDC_CHECK_ANCHOR_ENABLED, m_CheckAnchorEnabled);
	DDX_Control(pDX, IDC_CWGRAPH3D1, m_SurfaceGraph);
	DDX_Control(pDX, IDC_CWGRAPH3D2, m_ContourGraph);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CContoursDlg, CDialog)
	//{{AFX_MSG_MAP(CContoursDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PLOT1, OnButtonPlot1)
	ON_BN_CLICKED(IDC_BUTTON_PLOT2, OnButtonPlot2)
	ON_BN_CLICKED(IDC_BUTTON_PLOT3, OnButtonPlot3)
	ON_BN_CLICKED(IDC_CHECK_ANCHOR_ENABLED, OnCheckAnchorEnabled)
	ON_BN_CLICKED(IDC_CHECK_LABELS_VISIBLE, OnCheckLabelsVisible)
	ON_CBN_SELCHANGE(IDC_COMBO_LABEL_COLOR, OnSelchangeComboLabelColor)
	ON_CBN_SELCHANGE(IDC_COMBO_LINE_COLOR, OnSelchangeComboLineColor)
	ON_CBN_SELCHANGE(IDC_COMBO_LINE_STYLE, OnSelchangeComboLineStyle)
	ON_BN_CLICKED(IDC_RADIO_INTERVAL, OnRadioInterval)
	ON_BN_CLICKED(IDC_RADIO_LEVELS, OnRadioLevels)
	ON_EN_CHANGE(IDC_EDIT_LEVELS, OnChangeEditLevels)
	ON_EN_CHANGE(IDC_EDIT_ANCHOR, OnChangeEditAnchor)
	ON_EN_CHANGE(IDC_EDIT_INTERVAL, OnChangeEditInterval)
	ON_EN_CHANGE(IDC_EDIT_LABEL_FORMAT, OnChangeEditLabelFormat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContoursDlg message handlers

bool editingLevels, editingInterval, editingAnchor, refreshing;
const CNiColor black;
const CNiColor red(255, 0, 0);
const CNiColor green(0, 255, 0);
const CNiColor blue(0, 0, 255);

BOOL CContoursDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize controls
	editingLevels = false;
	editingInterval = false;
	editingAnchor = false;
	refreshing = false;
	InitControls();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CContoursDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CContoursDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


#define PI 3.1415926535

void CContoursDlg::OnButtonPlot1() 
{
	// Generate data
	CNiReal64Vector t(21);
	CNiReal64Matrix zData(21,21);
	int i, j;

	for (i = 0; i < 21; i++)
		t[i] = (i / 20.0 - 0.5) * 2 * PI;

	for (i = 0; i < 21; i++)
		for (j = 0; j < 21; j++) 
			zData(j, i) = sinh(t[i]) * cos(t[j]);

	// Plot the data
	m_SurfaceGraph.Plot3DSurface(t, t, zData);
	m_ContourGraph.Plot3DSurface(t, t, zData);

	// Reset the contour level mode to number of levels
	m_SurfaceGraph.Plots.Item(1).Contours.Levels = 5;
	m_ContourGraph.Plots.Item(1).Contours.Levels = 5;

	// Refresh controls
	RefreshControls();
}

void CContoursDlg::OnButtonPlot2() 
{
	// Generate data
	CNiReal64Vector t(21);
	CNiReal64Matrix zData(21, 21);
	int i, j;

	for (i = 0; i < 21; i++)
		t[i] = (i / 20.0 - 0.5) * 2;

	for (i = 0; i < 21; i++)
		for (j = 0; j < 21; j++)
			zData(j, i) = -(t[i] * t[i] + pow(pow(t[j], 2.0), 1.0/3.0));

	// Plot the data
	m_SurfaceGraph.Plot3DSurface(t, t, zData);
	m_ContourGraph.Plot3DSurface(t, t, zData);

	// Reset the contour level mode to number of levels
	m_SurfaceGraph.Plots.Item(1).Contours.Levels = 5;
	m_ContourGraph.Plots.Item(1).Contours.Levels = 5;

	// Refresh controls
	RefreshControls();
}

void CContoursDlg::OnButtonPlot3() 
{
	// Generate data
	CNiReal64Vector t(21);
	CNiReal64Matrix zData(21, 21);
	int i, j;

	for (i = 0; i < 21; i++)
		t[i] = (i / 20.0 - 0.5) * 8;
	for (i = 0; i < 21; i++)
		for (j = 0; j < 21; j++) 
			zData(j, i) = 8 * exp(-(t[i] * t[i] + t[j] * t[j]) / 4);
	
	// Plot the data
	m_SurfaceGraph.Plot3DSurface(t, t, zData);
	m_ContourGraph.Plot3DSurface(t, t, zData);

	// Reset the contour level mode to number of levels
	m_SurfaceGraph.Plots.Item(1).Contours.Levels = 5;
	m_ContourGraph.Plots.Item(1).Contours.Levels = 5;

	// Refresh controls
	RefreshControls();	
}

void CContoursDlg::OnCheckAnchorEnabled() 
{
    m_SurfaceGraph.Plots.Item(1).Contours.AnchorEnabled = m_CheckAnchorEnabled.GetCheck() ? true : false;
	m_ContourGraph.Plots.Item(1).Contours.AnchorEnabled = m_CheckAnchorEnabled.GetCheck() ? true : false;
	m_EditAnchor.EnableWindow(m_CheckAnchorEnabled.GetCheck());
}

void CContoursDlg::OnCheckLabelsVisible() 
{
	m_SurfaceGraph.Plots.Item(1).Contours.LabelVisible = m_CheckLabelsVisible.GetCheck() ? true : false;
	m_ContourGraph.Plots.Item(1).Contours.LabelVisible = m_CheckLabelsVisible.GetCheck() ? true : false;
}

void CContoursDlg::OnSelchangeComboLabelColor() 
{
	CNiColor color;
	switch (m_ComboLabelColor.GetCurSel()) 
	{
		case 0:	
			color = black;
			break;
		case 1:	
			color = red;
			break;
		case 2:
			color = green;
			break;
		case 3:
			color = blue;
			break;
	}
		
	m_SurfaceGraph.Plots.Item(1).Contours.LabelColor = color;
	m_ContourGraph.Plots.Item(1).Contours.LabelColor = color;
}

void CContoursDlg::OnSelchangeComboLineColor() 
{
	CNiColor color;

	switch (m_ComboLineColor.GetCurSel()) 
	{
		case 0:					//black
			color = black;
			break;
		case 1:					//red
			color = red;
			break;
		case 2:					//green
			color = green;
			break;
		case 3:					//blue
			color = blue;
			break;
	}
	m_SurfaceGraph.Plots.Item(1).Contours.LineColor = color;
	m_ContourGraph.Plots.Item(1).Contours.LineColor = color;
}

void CContoursDlg::OnSelchangeComboLineStyle() 
{
	CNiContours::LineStyles style;
	switch (m_ComboLineStyle.GetCurSel()) 
	{
		case 0:
			style = CNiContours::Solid;
			break;
		case 1:
			style = CNiContours::Dot;
			break;
		case 2:
			style = CNiContours::Dash;
			break;
		case 3:
			style = CNiContours::DashDot;
			break;
	}
	m_SurfaceGraph.Plots.Item(1).Contours.LineStyle = style;
	m_ContourGraph.Plots.Item(1).Contours.LineStyle = style;
}

void CContoursDlg::OnRadioInterval() 
{
	m_EditLevels.EnableWindow(FALSE);
	m_EditInterval.EnableWindow(TRUE);
	m_CheckAnchorEnabled.EnableWindow(TRUE);
	m_EditAnchor.EnableWindow(m_CheckAnchorEnabled.GetCheck());
	OnChangeEditInterval();
}

void CContoursDlg::OnRadioLevels() 
{
	m_EditLevels.EnableWindow(TRUE);
	m_EditInterval.EnableWindow(FALSE);
	m_CheckAnchorEnabled.EnableWindow(FALSE);
	m_EditAnchor.EnableWindow(FALSE);
	OnChangeEditLevels();
}

void CContoursDlg::OnChangeEditLevels() 
{
	if (refreshing)
		return;
	CString string;
	m_EditLevels.GetWindowText(string);
	
	int levels;
	if ((sscanf(string, "%d", &levels) != EOF) && (levels > 0)) 
	{
		m_SurfaceGraph.Plots.Item(1).Contours.Levels = levels;
		m_ContourGraph.Plots.Item(1).Contours.Levels = levels;
		editingLevels = true;
		RefreshControls();
		editingLevels = false;
	}
}

void CContoursDlg::OnChangeEditAnchor() 
{
	if (refreshing)
		return;
	CString string;
	m_EditAnchor.GetWindowText(string);
	double anchor;

	if (sscanf(string, "%lf", &anchor) != EOF) 
	{
		m_SurfaceGraph.Plots.Item(1).Contours.Anchor = anchor;
		m_ContourGraph.Plots.Item(1).Contours.Anchor = anchor;
		editingAnchor = true;
		RefreshControls();
		editingAnchor = false;
	}
}

void CContoursDlg::OnChangeEditInterval() 
{
	if (refreshing)
		return;
	CString string;
	m_EditInterval.GetWindowText(string);
	
	double interval;
	if ((sscanf(string, "%lf", &interval) != EOF) && (interval > 0.0)) 
	{
		m_SurfaceGraph.Plots.Item(1).Contours.Interval = interval;
		m_ContourGraph.Plots.Item(1).Contours.Interval = interval;
		editingInterval = true;
		RefreshControls();
		editingInterval = false;
	}
}

void CContoursDlg::OnChangeEditLabelFormat() 
{
	CString string;
	m_EditLabelFormat.GetWindowText(string);
	m_SurfaceGraph.Plots.Item(1).Contours.LabelFormat = string;
	m_ContourGraph.Plots.Item(1).Contours.LabelFormat = string;
	RefreshControls();
}

void CContoursDlg::InitControls()
{
	m_RadioLevels.SetCheck(TRUE);
	m_EditLevels.EnableWindow(TRUE);
	m_EditInterval.EnableWindow(FALSE);
	m_CheckAnchorEnabled.EnableWindow(FALSE);
	m_EditAnchor.EnableWindow(FALSE);
	m_CheckAnchorEnabled.SetCheck(TRUE);
	m_CheckLabelsVisible.SetCheck(TRUE);
	m_ComboLabelColor.SetCurSel(0);
	m_ComboLineColor.SetCurSel(0);
	m_ComboLineStyle.SetCurSel(0);
	RefreshControls();
}

void CContoursDlg::RefreshControls()
{
	refreshing = true;
	CString string;
	string.Format("%d", m_SurfaceGraph.Plots.Item(1).Contours.Levels);
	if (!editingLevels)
		m_EditLevels.SetWindowText(string);
	string.Format("%lf", m_SurfaceGraph.Plots.Item(1).Contours.Interval);
	if (!editingInterval)
		m_EditInterval.SetWindowText(string);
	string.Format("%lf", m_SurfaceGraph.Plots.Item(1).Contours.Anchor);
	if (!editingAnchor)
		m_EditAnchor.SetWindowText(string);
	refreshing = false;
}
