// Cursors3DDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cursors3D.h"
#include "Cursors3DDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SIZE 41

/////////////////////////////////////////////////////////////////////////////
// CCursors3DDlg dialog

CCursors3DDlg::CCursors3DDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCursors3DDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCursors3DDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCursors3DDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCursors3DDlg)
	DDX_Control(pDX, IDC_POSITION_SNAP_MODE, m_PositionSnapMode);
	DDX_Control(pDX, IDC_POINT_STYLE, m_PointStyle);
	DDX_Control(pDX, IDC_POINT_COLOR, m_PointColor);
	DDX_Control(pDX, IDC_PLANE_YZ, m_PlaneYZ);
	DDX_Control(pDX, IDC_PLANE_XZ, m_PlaneXZ);
	DDX_Control(pDX, IDC_PLANE_XY, m_PlaneXY);
	DDX_Control(pDX, IDC_PLANE_COLOR, m_PlaneColor);
	DDX_Control(pDX, IDC_LINE_STYLE, m_LineStyle);
	DDX_Control(pDX, IDC_LINE_COLOR, m_LineColor);
	DDX_Control(pDX, IDC_CURSOR_NAME_COLOR, m_CursorNameColor);
	DDX_Control(pDX, IDC_POSITION_SHOW, m_PositionShow);
	DDX_Control(pDX, IDC_GRAPH_PROJECTION, m_GraphProjection);
	DDX_Control(pDX, IDC_GRAPH_FAST_DRAW, m_GraphFastDraw);
	DDX_Control(pDX, IDC_CURSOR_VISIBLE, m_CursorVisible);
	DDX_Control(pDX, IDC_CURSOR_ENABLED, m_CursorEnabled);
	DDX_Control(pDX, IDC_CURSOR_NAME, m_CursorName);
	DDX_Control(pDX, IDC_GRAPH, m_Graph);
	DDX_Control(pDX, IDC_CURSOR_SHOW_NAME, m_CursorShowName);
	DDX_Control(pDX, IDC_POSITION_X, m_PositionX);
	DDX_Control(pDX, IDC_POSITION_Y, m_PositionY);
	DDX_Control(pDX, IDC_POSITION_Z, m_PositionZ);
	DDX_Control(pDX, IDC_CURSOR_COLOR_INDICATOR, m_CursorColorIndicator);
	DDX_Control(pDX, IDC_LINE_COLOR_INDICATOR, m_LineColorIndicator);
	DDX_Control(pDX, IDC_LINE_WIDTH, m_LineWidth);
	DDX_Control(pDX, IDC_PLANE_COLOR_INDICATOR, m_PlaneColorIndicator);
	DDX_Control(pDX, IDC_PLANE_TRANSPARENCY, m_PlaneTransparency);
	DDX_Control(pDX, IDC_POINT_COLOR_INDICATOR, m_PointColorIndicator);
	DDX_Control(pDX, IDC_POINT_SIZE, m_PointSize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCursors3DDlg, CDialog)
	//{{AFX_MSG_MAP(CCursors3DDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CURSOR_ENABLED, OnCursorEnabled)
	ON_BN_CLICKED(IDC_CURSOR_VISIBLE, OnCursorVisible)
	ON_BN_CLICKED(IDC_CURSOR_SHOW_NAME, OnCursorShowName)
	ON_BN_CLICKED(IDC_GRAPH_FAST_DRAW, OnGraphFastDraw)
	ON_BN_CLICKED(IDC_GRAPH_PROJECTION, OnGraphProjection)
	ON_BN_CLICKED(IDC_POSITION_SHOW, OnPositionShow)
	ON_EN_CHANGE(IDC_CURSOR_NAME, OnChangeCursorName)
	ON_BN_CLICKED(IDC_CURSOR_NAME_COLOR, OnCursorNameColor)
	ON_CBN_SELCHANGE(IDC_POSITION_SNAP_MODE, OnSelchangePositionSnapMode)
	ON_BN_CLICKED(IDC_POINT_COLOR, OnPointColor)
	ON_CBN_SELCHANGE(IDC_POINT_STYLE, OnSelchangePointStyle)
	ON_BN_CLICKED(IDC_LINE_COLOR, OnLineColor)
	ON_CBN_SELCHANGE(IDC_LINE_STYLE, OnSelchangeLineStyle)
	ON_BN_CLICKED(IDC_PLANE_COLOR, OnPlaneColor)
	ON_BN_CLICKED(IDC_PLANE_XY, OnPlaneXy)
	ON_BN_CLICKED(IDC_PLANE_XZ, OnPlaneXz)
	ON_BN_CLICKED(IDC_PLANE_YZ, OnPlaneYz)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCursors3DDlg message handlers

BOOL CCursors3DDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    CNiPlot3D plot = m_Graph.Plots.Item(1);
    plot.ColorMapStyle = CNiPlot3D::GrayScale;
    plot.Style = CNiPlot3D::HiddenLine;

    SetupSnapModes();
    SetupPointStyles();
    SetupLineStyles();

    m_Graph.FastDraw = true;
    m_Graph.ProjectionStyle = CNiGraph3D::Orthographic;

    m_Cursor = m_Graph.Cursors.Add();
    m_Cursor.Name = _T("Cursor 1");
    m_Cursor.Enabled = true;
    m_Cursor.Visible = true;
    m_Cursor.NameVisible = true;
    m_Cursor.TextColor = CNiColor(0, 0, 0);

    m_Cursor.XPosition = 5.0;
    m_Cursor.YPosition = 5.0;
    m_Cursor.ZPosition = 5.0;
    m_Cursor.PositionVisible = true;
    m_Cursor.SnapMode = CNiCursor3D::SnapNearestPlot;

    m_Cursor.PointSize = 10.0;
    m_Cursor.PointColor = CNiColor(0, 0, 128);
    m_Cursor.PointStyle = CNiCursor3D::SolidDiamond;

    m_Cursor.LineWidth = 1.0;
    m_Cursor.LineColor = CNiColor(255, 0, 0);
    m_Cursor.LineStyle = CNiCursor3D::LineSolid;

    m_Cursor.Transparency = 75;
    m_Cursor.PlaneColor = CNiColor(0, 128, 0);
    m_Cursor.XYPlaneVisible = false;
    m_Cursor.XZPlaneVisible = false;
    m_Cursor.YZPlaneVisible = false;

    RefreshControls();
    PlotDualSineSurface();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCursors3DDlg::PlotDualSineSurface()
{
	CNiReal64Vector xData(SIZE);
    CNiReal64Vector yData(SIZE);
    CNiReal64Matrix zData(SIZE, SIZE);
    int i, j;

    for (i = 0; i < SIZE; ++i)
        xData[i] = yData[i] = ((i - 20.0) / 20.0) * CNiMath::Pi;

    for (i = 0; i < SIZE; ++i)
    {
        for (j = 0; j < SIZE; ++j)
            zData(j, i) = sin(xData[i]) * cos(yData[j]) + 2.0;
    }

    m_Graph.Plot3DSurface(xData, yData, zData);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCursors3DDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCursors3DDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCursors3DDlg::RefreshControls()
{
    m_GraphFastDraw.SetCheck(m_Graph.FastDraw ? 1 : 0);
    m_GraphProjection.SetCheck(m_Graph.ProjectionStyle == CNiGraph3D::Perspective ? 1 : 0);

    m_CursorName.SetWindowText(m_Cursor.Name);
    m_CursorEnabled.SetCheck(m_Cursor.Enabled ? 1 : 0);
    m_CursorVisible.SetCheck(m_Cursor.Visible ? 1 : 0);
    m_CursorShowName.SetCheck(m_Cursor.NameVisible ? 1 : 0);
    m_CursorColorIndicator.OffColor = m_Cursor.TextColor;

    m_PositionX.Value = m_Cursor.XPosition;
    m_PositionY.Value = m_Cursor.YPosition;
    m_PositionZ.Value = m_Cursor.ZPosition;
    m_PositionShow.SetCheck(m_Cursor.PositionVisible ? 1 : 0);
    SelectComboBoxItem(m_PositionSnapMode, m_Cursor.SnapMode);

    m_PointSize.Value = m_Cursor.PointSize;
    m_PointColorIndicator.OffColor = m_Cursor.PointColor;
    SelectComboBoxItem(m_PointStyle, m_Cursor.PointStyle);

    m_LineWidth.Value = m_Cursor.LineWidth;
    m_LineColorIndicator.OffColor = m_Cursor.LineColor;
    SelectComboBoxItem(m_LineStyle, m_Cursor.LineStyle);

    m_PlaneTransparency.Value = m_Cursor.Transparency;
    m_PlaneColorIndicator.OffColor = m_Cursor.PlaneColor;
    m_PlaneXY.SetCheck(m_Cursor.XYPlaneVisible ? 1 : 0);
    m_PlaneXZ.SetCheck(m_Cursor.XZPlaneVisible ? 1 : 0);
    m_PlaneYZ.SetCheck(m_Cursor.YZPlaneVisible ? 1 : 0);
}

bool CCursors3DDlg::GetNewColor(const CNiColor& oldColor, CNiColor& newColor)
{
    bool newColorPicked = false;

    CColorDialog colorDialog(RGB(oldColor.Red, oldColor.Green, oldColor.Blue), CC_FULLOPEN);
    if (colorDialog.DoModal() == IDOK)
    {
        newColor = colorDialog.GetColor();
        newColorPicked = true;
    }

    return newColorPicked;
}

void CCursors3DDlg::SelectComboBoxItem(CComboBox& comboBox, int itemData)
{
    int comboBoxCount = comboBox.GetCount();
    for (int i = 0; i < comboBoxCount; ++i)
    {
        if (comboBox.GetItemData(i) == itemData)
        {
            comboBox.SetCurSel(i);
            break;
        }
    }
}

void CCursors3DDlg::SetupSnapModes()
{
    int currentPos;

    currentPos = m_PositionSnapMode.AddString(_T("Fixed"));
    m_PositionSnapMode.SetItemData(currentPos, CNiCursor3D::SnapFixed);

    currentPos = m_PositionSnapMode.AddString(_T("Nearest Point"));
    m_PositionSnapMode.SetItemData(currentPos, CNiCursor3D::SnapNearestPlot);

    currentPos = m_PositionSnapMode.AddString(_T("Snap To Plot"));
    m_PositionSnapMode.SetItemData(currentPos, CNiCursor3D::SnapToPlot);
}

void CCursors3DDlg::SetupPointStyles()
{
    int currentPos;

    currentPos = m_PointStyle.AddString(_T("None"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::None);

    currentPos = m_PointStyle.AddString(_T("Empty Square"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::EmptySquare);

    currentPos = m_PointStyle.AddString(_T("Solid Square"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::SolidSquare);

    currentPos = m_PointStyle.AddString(_T("Asterisk"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::Asterisk);

    currentPos = m_PointStyle.AddString(_T("Solid Diamond"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::SolidDiamond);

    currentPos = m_PointStyle.AddString(_T("Empty Circle"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::EmptyCircle);

    currentPos = m_PointStyle.AddString(_T("Solid Circle"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::SolidCircle);

    currentPos = m_PointStyle.AddString(_T("Bold X"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::BoldX);

    currentPos = m_PointStyle.AddString(_T("Wireframe Sphere"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::WireframeSphere);

    currentPos = m_PointStyle.AddString(_T("Solid Sphere"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::SolidSphere);

    currentPos = m_PointStyle.AddString(_T("Wireframe Cube"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::WireframeCube);

    currentPos = m_PointStyle.AddString(_T("Solid Cube"));
    m_PointStyle.SetItemData(currentPos, CNiCursor3D::SolidCube);

}

void CCursors3DDlg::SetupLineStyles()
{
    int currentPos;

    currentPos = m_LineStyle.AddString(_T("None"));
    m_LineStyle.SetItemData(currentPos, CNiCursor3D::LineNone);

    currentPos = m_LineStyle.AddString(_T("Solid"));
    m_LineStyle.SetItemData(currentPos, CNiCursor3D::LineSolid);

    currentPos = m_LineStyle.AddString(_T("Dashed"));
    m_LineStyle.SetItemData(currentPos, CNiCursor3D::LineDash);

    currentPos = m_LineStyle.AddString(_T("Dotted"));
    m_LineStyle.SetItemData(currentPos, CNiCursor3D::LineDot);

    currentPos = m_LineStyle.AddString(_T("Dash-Dot"));
    m_LineStyle.SetItemData(currentPos, CNiCursor3D::LineDashDot);
}

void CCursors3DDlg::OnGraphFastDraw() 
{
    m_Graph.FastDraw = m_GraphFastDraw.GetCheck() == 1 ? true : false;
}

void CCursors3DDlg::OnGraphProjection() 
{
    if (m_GraphProjection.GetCheck() == 1)
        m_Graph.ProjectionStyle = CNiGraph3D::Perspective;
    else
        m_Graph.ProjectionStyle = CNiGraph3D::Orthographic;
}

void CCursors3DDlg::OnChangeCursorName() 
{
    CString cursorName;
    m_CursorName.GetWindowText(cursorName);
    m_Cursor.Name = cursorName;
}

void CCursors3DDlg::OnCursorEnabled() 
{
    m_Cursor.Enabled = (m_CursorEnabled.GetCheck() == 1);
}

void CCursors3DDlg::OnCursorVisible() 
{
    m_Cursor.Visible = (m_CursorVisible.GetCheck() == 1);
}

void CCursors3DDlg::OnCursorShowName() 
{
    m_Cursor.NameVisible = (m_CursorShowName.GetCheck() == 1);
}


BEGIN_EVENTSINK_MAP(CCursors3DDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CCursors3DDlg)
	ON_EVENT(CCursors3DDlg, IDC_POSITION_X, 1 /* ValueChanged */, OnValueChangedPositionX, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	ON_EVENT(CCursors3DDlg, IDC_POSITION_Y, 1 /* ValueChanged */, OnValueChangedPositionY, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	ON_EVENT(CCursors3DDlg, IDC_POSITION_Z, 1 /* ValueChanged */, OnValueChangedPositionZ, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	ON_EVENT(CCursors3DDlg, IDC_POINT_SIZE, 1 /* ValueChanged */, OnValueChangedPointSize, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	ON_EVENT(CCursors3DDlg, IDC_LINE_WIDTH, 1 /* ValueChanged */, OnValueChangedLineWidth, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	ON_EVENT(CCursors3DDlg, IDC_PLANE_TRANSPARENCY, 1 /* ValueChanged */, OnValueChangedPlaneTransparency, VTS_PVARIANT VTS_PVARIANT VTS_BOOL)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CCursors3DDlg::OnValueChangedPositionX(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.XPosition = m_PositionX.Value;
}

void CCursors3DDlg::OnValueChangedPositionY(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.YPosition = m_PositionY.Value;
}

void CCursors3DDlg::OnValueChangedPositionZ(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.ZPosition = m_PositionZ.Value;
}

void CCursors3DDlg::OnPositionShow() 
{
    m_Cursor.PositionVisible = (m_PositionShow.GetCheck() == 1) ? true : false;
}

void CCursors3DDlg::OnCursorNameColor() 
{
    CNiColor newColor;
    if (GetNewColor(m_Cursor.TextColor, newColor))
    {
        m_Cursor.TextColor = newColor;
        m_CursorColorIndicator.OffColor = newColor;
    }
}

void CCursors3DDlg::OnSelchangePositionSnapMode() 
{
    int currentSel = m_PositionSnapMode.GetCurSel();
    m_Cursor.SnapMode = static_cast<CNiCursor3D::SnapModes>(m_PositionSnapMode.GetItemData(currentSel));
}

void CCursors3DDlg::OnValueChangedPointSize(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.PointSize = m_PointSize.Value;
}

void CCursors3DDlg::OnPointColor() 
{
    CNiColor newColor;
    if (GetNewColor(m_Cursor.PointColor, newColor))
    {
        m_Cursor.PointColor = newColor;
        m_PointColorIndicator.OffColor = newColor;
    }
}

void CCursors3DDlg::OnSelchangePointStyle() 
{
    int currentSel = m_PointStyle.GetCurSel();
    m_Cursor.PointStyle = static_cast<CNiCursor3D::PointStyles>(m_PointStyle.GetItemData(currentSel));
}

void CCursors3DDlg::OnValueChangedLineWidth(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.LineWidth = m_LineWidth.Value;
}

void CCursors3DDlg::OnLineColor() 
{
    CNiColor newColor;
    if (GetNewColor(m_Cursor.LineColor, newColor))
    {
        m_Cursor.LineColor = newColor;
        m_LineColorIndicator.OffColor = newColor;
    }
}

void CCursors3DDlg::OnSelchangeLineStyle() 
{
    int currentSel = m_LineStyle.GetCurSel();
    m_Cursor.LineStyle = static_cast<CNiCursor3D::LineStyles>(m_LineStyle.GetItemData(currentSel));
}

void CCursors3DDlg::OnValueChangedPlaneTransparency(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange) 
{
    m_Cursor.Transparency = static_cast<long>(m_PlaneTransparency.Value);
}

void CCursors3DDlg::OnPlaneColor() 
{
    CNiColor newColor;
    if (GetNewColor(m_Cursor.PlaneColor, newColor))
    {
        m_Cursor.PlaneColor = newColor;
        m_PlaneColorIndicator.OffColor = newColor;
    }
}

void CCursors3DDlg::OnPlaneXy() 
{
    m_Cursor.XYPlaneVisible = (m_PlaneXY.GetCheck() == 1);
}

void CCursors3DDlg::OnPlaneXz() 
{
    m_Cursor.XZPlaneVisible = (m_PlaneXZ.GetCheck() == 1);
}

void CCursors3DDlg::OnPlaneYz() 
{
    m_Cursor.YZPlaneVisible = (m_PlaneYZ.GetCheck() == 1);
}
