// Cursors3DDlg.h : header file
//
//{{AFX_INCLUDES()
#include "NiGraph3D.h"
#include "NiNumEdit.h"
#include "NiButton.h"
//}}AFX_INCLUDES

#if !defined(AFX_CURSORS3DDLG_H__5C74C1C3_4D3C_46B0_9A5F_0B4C5FA4381D__INCLUDED_)
#define AFX_CURSORS3DDLG_H__5C74C1C3_4D3C_46B0_9A5F_0B4C5FA4381D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCursors3DDlg dialog

class CCursors3DDlg : public CDialog
{
// Construction
public:
	CCursors3DDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CCursors3DDlg)
	enum { IDD = IDD_CURSORS3D_DIALOG };
	CComboBox	m_PositionSnapMode;
	CComboBox	m_PointStyle;
	CButton	m_PointColor;
	CButton	m_PlaneYZ;
	CButton	m_PlaneXZ;
	CButton	m_PlaneXY;
	CButton	m_PlaneColor;
	CComboBox	m_LineStyle;
	CButton	m_LineColor;
	CButton	m_CursorNameColor;
	CButton	m_PositionShow;
	CButton	m_GraphProjection;
	CButton	m_GraphFastDraw;
	CButton	m_CursorVisible;
	CButton	m_CursorEnabled;
	CEdit	m_CursorName;
	CNiGraph3D	m_Graph;
	CButton	m_CursorShowName;
	CNiNumEdit	m_PositionX;
	CNiNumEdit	m_PositionY;
	CNiNumEdit	m_PositionZ;
	CNiButton	m_CursorColorIndicator;
	CNiButton	m_LineColorIndicator;
	CNiNumEdit	m_LineWidth;
	CNiButton	m_PlaneColorIndicator;
	CNiNumEdit	m_PlaneTransparency;
	CNiButton	m_PointColorIndicator;
	CNiNumEdit	m_PointSize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCursors3DDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

    CNiCursor3D m_Cursor;

    void PlotDualSineSurface();
    void RefreshControls();
    bool GetNewColor(const CNiColor& oldColor, CNiColor& newColor);
    void SelectComboBoxItem(CComboBox& comboBox, int itemData);
    void SetupSnapModes();
    void SetupPointStyles();
    void SetupLineStyles();

	// Generated message map functions
	//{{AFX_MSG(CCursors3DDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCursorEnabled();
	afx_msg void OnCursorVisible();
	afx_msg void OnCursorShowName();
	afx_msg void OnGraphFastDraw();
	afx_msg void OnGraphProjection();
	afx_msg void OnValueChangedPositionX(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnValueChangedPositionY(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnValueChangedPositionZ(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnPositionShow();
	afx_msg void OnChangeCursorName();
	afx_msg void OnCursorNameColor();
	afx_msg void OnSelchangePositionSnapMode();
	afx_msg void OnValueChangedPointSize(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnPointColor();
	afx_msg void OnSelchangePointStyle();
	afx_msg void OnValueChangedLineWidth(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnLineColor();
	afx_msg void OnSelchangeLineStyle();
	afx_msg void OnValueChangedPlaneTransparency(VARIANT FAR* Value, VARIANT FAR* PreviousValue, BOOL OutOfRange);
	afx_msg void OnPlaneColor();
	afx_msg void OnPlaneXy();
	afx_msg void OnPlaneXz();
	afx_msg void OnPlaneYz();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CURSORS3DDLG_H__5C74C1C3_4D3C_46B0_9A5F_0B4C5FA4381D__INCLUDED_)
