// EventsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Events.h"
#include "EventsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsDlg dialog

CEventsDlg::CEventsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEventsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEventsDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEventsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEventsDlg)
	DDX_Control(pDX, IDC_STATIC_ZCENTER, m_ZCenter);
	DDX_Control(pDX, IDC_STATIC_YCENTER, m_YCenter);
	DDX_Control(pDX, IDC_STATIC_XCENTER, m_XCenter);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_ZFAR, m_ZFar);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_ZNEAR, m_ZNear);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_YNEAR, m_YNear);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_YFAR, m_YFar);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_XNEAR, m_XNear);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_XFAR, m_XFar);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_SHIFT, m_PlotAreaShift);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_MOUSESTATE, m_PlotAreaMouseState);
	DDX_Control(pDX, IDC_STATIC_PLOTAREA_BUTTON, m_PlotAreaButton);
	DDX_Control(pDX, IDC_STATIC_PLOT_ZPOS, m_PlotZPos);
	DDX_Control(pDX, IDC_STATIC_PLOT_YPOS, m_PlotYPos);
	DDX_Control(pDX, IDC_STATIC_PLOT_XPOS, m_PlotXPos);
	DDX_Control(pDX, IDC_STATIC_PLOT_SHIFT, m_PlotShift);
	DDX_Control(pDX, IDC_STATIC_PLOT_POINTJ, m_PlotPointJ);
	DDX_Control(pDX, IDC_STATIC_PLOT_POINTI, m_PlotPointI);
	DDX_Control(pDX, IDC_STATIC_PLOT_PLOTINDEX, m_PlotIndex);
	DDX_Control(pDX, IDC_STATIC_PLOT_MOUSESTATE, m_PlotMouseState);
	DDX_Control(pDX, IDC_STATIC_PLOT_BUTTON, m_PlotButton);
	DDX_Control(pDX, IDC_STATIC_LONGITUDE, m_Longitude);
	DDX_Control(pDX, IDC_STATIC_LATITUDE, m_Latitude);
	DDX_Control(pDX, IDC_STATIC_DISTANCE, m_Distance);
	DDX_Control(pDX, IDC_RADIO_ZPR, m_RadioZPR);
	DDX_Control(pDX, IDC_CWGRAPH3D, m_graph);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEventsDlg, CDialog)
	//{{AFX_MSG_MAP(CEventsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PLOT, OnButtonPlot)
	ON_BN_CLICKED(IDC_RADIO_ALL, OnRadioAll)
	ON_BN_CLICKED(IDC_RADIO_PLOT_AREA, OnRadioPlotArea)
	ON_BN_CLICKED(IDC_RADIO_ZPR, OnRadioZpr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsDlg message handlers

BOOL CEventsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_RadioZPR.SetCheck(TRUE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEventsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEventsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CEventsDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CEventsDlg)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 1 /* PlotMouseDown */, OnPlotMouseDownCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PI2 VTS_PI4 VTS_PI4)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 2 /* PlotMouseMove */, OnPlotMouseMoveCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PI2 VTS_PI4 VTS_PI4)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 3 /* PlotMouseUp */, OnPlotMouseUpCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PI2 VTS_PI4 VTS_PI4)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 4 /* PlotAreaMouseDown */, OnPlotAreaMouseDownCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 5 /* PlotAreaMouseMove */, OnPlotAreaMouseMoveCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 6 /* PlotAreaMouseUp */, OnPlotAreaMouseUpCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 7 /* Zoom */, OnZoomCwgraph3d, VTS_PVARIANT)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 8 /* Pan */, OnPanCwgraph3d, VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT)
	ON_EVENT(CEventsDlg, IDC_CWGRAPH3D, 9 /* Rotate */, OnRotateCwgraph3d, VTS_PVARIANT VTS_PVARIANT)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//////////////////////////////////////////////////////////////////////////////
//
//	Event Handlers
//
//////////////////////////////////////////////////////////////////////////////

#define PI 3.1415926535

void CEventsDlg::OnButtonPlot() 
{
	// Generate data
	CNiReal64Vector t(41);
	CNiReal64Matrix zData1(41, 41);
	CNiReal64Matrix zData2(41, 41);
	int i;

	for (i = 0; i < 41; i++)
		t[i] = (i - 20.0)/20.0 * PI;
	for (i = 0; i < 41; i++)
	{
		for (int j = 0; j < 41; j++) 
		{
			zData1(j, i) = sin(t[i]) * cos(t[j]);
			zData2(j, i) = cos(t[i]) * cos(t[j]);
		}
	}

	// Plot the data
	m_graph.GetPlots().Item(1).Plot3DSurface(t, t, zData1);
	m_graph.GetPlots().Item(2).Plot3DSurface(t, t, zData2);
}

void CEventsDlg::OnRadioAll() 
{
	m_graph.SetTrackMode(CNiGraph3D::TrackAllEvents);
}

void CEventsDlg::OnRadioPlotArea() 
{
	m_graph.SetTrackMode(CNiGraph3D::TrackPlotAreaEvents);
}

void CEventsDlg::OnRadioZpr() 
{
	m_graph.SetTrackMode(CNiGraph3D::TrackZoomPanRotate);
}

void CEventsDlg::OnPlotMouseDownCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XData, VARIANT FAR* YData, VARIANT FAR* ZData, short FAR* PlotIndex, long FAR* PointI, long FAR* PointJ) 
{
	PlotCommon(CString("Down"), Button, Shift, XData, YData, ZData, PlotIndex, PointI, PointJ);
}

void CEventsDlg::OnPlotMouseMoveCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XData, VARIANT FAR* YData, VARIANT FAR* ZData, short FAR* PlotIndex, long FAR* PointI, long FAR* PointJ) 
{
	PlotCommon(CString("Move"), Button, Shift, XData, YData, ZData, PlotIndex, PointI, PointJ);
}

void CEventsDlg::OnPlotMouseUpCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XData, VARIANT FAR* YData, VARIANT FAR* ZData, short FAR* PlotIndex, long FAR* PointI, long FAR* PointJ) 
{
	PlotCommon(CString("Up"), Button, Shift, XData, YData, ZData, PlotIndex, PointI, PointJ);	
}

void CEventsDlg::PlotCommon(CString MouseState, short FAR * Button, short FAR * Shift, VARIANT FAR * XData, VARIANT FAR * YData, VARIANT FAR * ZData, short FAR * PlotIndex, long FAR * PointI, long FAR * PointJ) 
{
	CString Data;

	m_PlotMouseState.SetWindowText(MouseState);
	m_PlotButton.SetWindowText(CString(*Button & 1 ? "Left " : "") + CString(*Button & 2 ? "Right " : "") + CString(*Button & 4 ? "Middle " : ""));
	m_PlotShift.SetWindowText(CString(*Shift & 1 ? "Shift " : "") + CString(*Shift & 2 ? "Ctrl " : "") + CString(*Shift & 4 ? "Alt " : ""));
	
	Data.Format("%lf", XData->dblVal);
	m_PlotXPos.SetWindowText(Data);

	Data.Format("%lf", YData->dblVal);
	m_PlotYPos.SetWindowText(Data);

	Data.Format("%lf", ZData->dblVal);
	m_PlotZPos.SetWindowText(Data);

	CString string;
	string.Format("%d", *PlotIndex);
	m_PlotIndex.SetWindowText(string);
	string.Format("%d", *PointI);
	m_PlotPointI.SetWindowText(string);
	string.Format("%d", *PointJ);
	m_PlotPointJ.SetWindowText(string);
}

void CEventsDlg::OnPlotAreaMouseDownCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XNear, VARIANT FAR* YNear, VARIANT FAR* ZNear, VARIANT FAR* XFar, VARIANT FAR* YFar, VARIANT FAR* ZFar) 
{
	PlotAreaCommon(CString("Down"), Button, Shift, XNear, YNear, ZNear, XFar, YFar, ZFar);	
}

void CEventsDlg::OnPlotAreaMouseMoveCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XNear, VARIANT FAR* YNear, VARIANT FAR* ZNear, VARIANT FAR* XFar, VARIANT FAR* YFar, VARIANT FAR* ZFar) 
{
	PlotAreaCommon(CString("Move"), Button, Shift, XNear, YNear, ZNear, XFar, YFar, ZFar);	
}

void CEventsDlg::OnPlotAreaMouseUpCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XNear, VARIANT FAR* YNear, VARIANT FAR* ZNear, VARIANT FAR* XFar, VARIANT FAR* YFar, VARIANT FAR* ZFar) 
{
	PlotAreaCommon(CString("Up"), Button, Shift, XNear, YNear, ZNear, XFar, YFar, ZFar);
}

void CEventsDlg::PlotAreaCommon(CString MouseState, short FAR * Button, short FAR * Shift, VARIANT FAR * XNear, VARIANT FAR * YNear, VARIANT FAR * ZNear, VARIANT FAR * XFar, VARIANT FAR * YFar, VARIANT FAR * ZFar) 
{
	CString Position;

	m_PlotAreaMouseState.SetWindowText(MouseState);
	m_PlotAreaButton.SetWindowText(CString(*Button & 1 ? "Left " : "") + CString(*Button & 2 ? "Right " : "") + CString(*Button & 4 ? "Middle " : ""));
	m_PlotAreaShift.SetWindowText(CString(*Shift & 1 ? "Shift " : "") + CString(*Shift & 2 ? "Ctrl " : "") + CString(*Shift & 4 ? "Alt " : ""));
	Position.Format("%lf", XNear->dblVal);
	m_XNear.SetWindowText(Position);
	Position.Format("%lf", YNear->dblVal);
	m_YNear.SetWindowText(Position);
	Position.Format("%lf", ZNear->dblVal);
	m_ZNear.SetWindowText(Position);
	Position.Format("%lf", XFar->dblVal);
	m_XFar.SetWindowText(Position);
	Position.Format("%lf", YFar->dblVal);
	m_YFar.SetWindowText(Position);
	Position.Format("%lf", ZFar->dblVal);
	m_ZFar.SetWindowText(Position);
}

void CEventsDlg::OnZoomCwgraph3d(VARIANT FAR* NewDistance) 
{
	CString distance;
	distance.Format("%lf", NewDistance->dblVal);
	m_Distance.SetWindowText(distance);
}

void CEventsDlg::OnPanCwgraph3d(VARIANT FAR* NewXCenter, VARIANT FAR* NewYCenter, VARIANT FAR* NewZCenter) 
{
	CString Center;
	Center.Format("%lf", NewXCenter->dblVal);
	m_XCenter.SetWindowText(Center);

	Center.Format("%lf", NewYCenter->dblVal);
	m_YCenter.SetWindowText(Center);

	Center.Format("%lf", NewZCenter->dblVal);
	m_ZCenter.SetWindowText(Center);
}

void CEventsDlg::OnRotateCwgraph3d(VARIANT FAR* NewLatitude, VARIANT FAR* NewLongitude) 
{
	CString View;
	View.Format("%lf", NewLatitude->dblVal);
	m_Latitude.SetWindowText(View);

	View.Format("%lf", NewLongitude->dblVal);
	m_Longitude.SetWindowText(View);
}
