// Plot StylesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Plot Styles.h"
#include "Plot StylesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlotStylesDlg dialog

CPlotStylesDlg::CPlotStylesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlotStylesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlotStylesDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPlotStylesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlotStylesDlg)
	DDX_Control(pDX, IDC_RADIO_POINT, m_Point);
	DDX_Control(pDX, IDC_RADIO_SURFACE_NORMAL, m_SurfaceNormal);
	DDX_Control(pDX, IDC_RADIO_SURFACE_LINE, m_SurfaceLine);
	DDX_Control(pDX, IDC_RADIO_SURFACE_CONTOUR, m_SurfaceContour);
	DDX_Control(pDX, IDC_RADIO_LINE_POINT, m_LinePoint);
	DDX_Control(pDX, IDC_RADIO_LINE, m_Line);
	DDX_Control(pDX, IDC_RADIO_CONTOUR, m_Contour);
	DDX_Control(pDX, IDC_RADIO_SURFACE, m_Surface);
	DDX_Control(pDX, IDC_RADIO_HIDDEN_LINE, m_HiddenLine);
	DDX_Control(pDX, IDC_CWGRAPH3D1, m_Graph3D);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlotStylesDlg, CDialog)
	//{{AFX_MSG_MAP(CPlotStylesDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLOT_CURVE, OnPlotCurve)
	ON_BN_CLICKED(IDC_PLOT_DUAL_SINE, OnPlotDualSine)
	ON_BN_CLICKED(IDC_PLOT_RANDOM, OnPlotRandom)
	ON_BN_CLICKED(IDC_PLOT_TORUS, OnPlotTorus)
	ON_BN_CLICKED(IDC_RADIO_CONTOUR, OnRadioContour)
	ON_BN_CLICKED(IDC_RADIO_HIDDEN_LINE, OnRadioHiddenLine)
	ON_BN_CLICKED(IDC_RADIO_LINE, OnRadioLine)
	ON_BN_CLICKED(IDC_RADIO_LINE_POINT, OnRadioLinePoint)
	ON_BN_CLICKED(IDC_RADIO_POINT, OnRadioPoint)
	ON_BN_CLICKED(IDC_RADIO_SURFACE, OnRadioSurface)
	ON_BN_CLICKED(IDC_RADIO_SURFACE_CONTOUR, OnRadioSurfaceContour)
	ON_BN_CLICKED(IDC_RADIO_SURFACE_LINE, OnRadioSurfaceLine)
	ON_BN_CLICKED(IDC_RADIO_SURFACE_NORMAL, OnRadioSurfaceNormal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlotStylesDlg message handlers

BOOL CPlotStylesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlotStylesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlotStylesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//////////////////////////////////////////////////////////////////////////////
//
//	Button Handlers
//
//////////////////////////////////////////////////////////////////////////////


#define PI 3.1415926535
bool m_bCurve=false;

void CPlotStylesDlg::OnPlotCurve() 
{
	CNiReal64Vector xData(41);
	CNiReal64Vector yData(41);
	CNiReal64Vector zData(41);
	for (int i = 0; i < 41; i++) 
	{
		xData[i] = cos(i/3.0);
		yData[i] = sin(i/3.0);
		zData[i] = i;
	}

	
	// Plot the data
	m_Graph3D.Plot3DCurve(xData, yData, zData);

	// Set flag saying that we have a curve plot
	m_bCurve = true;

	// Update the radio buttons
	UpdateRadioButtons();

	// Disable the surface-only plot styles
	m_HiddenLine.EnableWindow(FALSE);
	m_Surface.EnableWindow(FALSE);
	m_SurfaceLine.EnableWindow(FALSE);
	m_SurfaceNormal.EnableWindow(FALSE);
	m_Contour.EnableWindow(FALSE);
	m_SurfaceContour.EnableWindow(FALSE);
	
}

void CPlotStylesDlg::OnPlotDualSine() 
{
	// Generate data
	CNiReal64Vector xData(41);
	CNiReal64Vector yData(41);
	CNiReal64Matrix zData(41,41);
	int i;
	for (i = 0; i < 41; i++) 
	{
		xData[i] = (i - 20.0)/20.0 * PI;
		yData[i] = (i - 20.0)/20.0 * PI;
	}
	for (i = 0; i < 41; i++)
		for (int j = 0; j < 41; j++)
			zData(j,i) = sin(xData[i])*cos(yData[j]);

	// Reset properties after a curve plot
	if (m_bCurve)
		ResetAfterCurve();

	// Plot the data
	m_Graph3D.Plot3DSurface(xData, yData, zData);
	
}

void CPlotStylesDlg::OnPlotRandom() 
{
	// Generate data
	CNiReal64Matrix zData(10,10);
	for (long i = 0; i < 10; i++)
		for (long j = 0; j < 10; j++)
			zData(j,i) = rand()/32767.0;

	// Reset properties after a curve plot
	if (m_bCurve)
		ResetAfterCurve();

	// Plot the data
	m_Graph3D.Plot3DSimpleSurface(zData);
	
}

void CPlotStylesDlg::OnPlotTorus() 
{
	// Generate data
	double t[41];
	CNiReal64Matrix xData(41,41);
	CNiReal64Matrix yData(41,41);
	CNiReal64Matrix zData(41,41);
	long i;
	for (i = 0; i < 41; i++)
		t[i] = (i - 20.0)/20.0 * PI;
	for (i = 0; i < 41; i++)
		for (long j = 0; j < 41; j++) 
		{
			xData(40-j,i) = (cos(t[j]) + 3.0) * cos(t[i]);
			yData(40-j,i) = (cos(t[j]) + 3.0) * sin(t[i]);
			zData(40-j,i) = sin(t[j]);
		}

	// Reset properties after a curve plot
	if (m_bCurve)
		ResetAfterCurve();

	// Plot the data
	m_Graph3D.Plot3DParametricSurface(xData, yData, zData);
}

void CPlotStylesDlg::UpdateRadioButtons() 
{
	// Update the status of the radio buttons
	CNiPlot3D::PlotStyles style=m_Graph3D.GetPlots().Item(1).GetStyle();
	m_Point.SetCheck(			(style == CNiPlot3D::Point)			? 1 : 0);
	m_Line.SetCheck(			(style == CNiPlot3D::Line)			? 1 : 0);
	m_LinePoint.SetCheck(		(style == CNiPlot3D::LinePoint)		? 1 : 0);
	m_HiddenLine.SetCheck(		(style == CNiPlot3D::HiddenLine)	? 1 : 0);
	m_Surface.SetCheck(			(style == CNiPlot3D::Surface)		? 1 : 0);
	m_SurfaceLine.SetCheck(		(style == CNiPlot3D::SurfaceLine)	? 1 : 0);
	m_SurfaceNormal.SetCheck(	(style == CNiPlot3D::SurfaceNormal)	? 1 : 0);
	m_Contour.SetCheck(			(style == CNiPlot3D::ContourLine)	? 1 : 0);
	m_SurfaceContour.SetCheck(	(style == CNiPlot3D::SurfaceContour)? 1 : 0);
}

void CPlotStylesDlg::ResetAfterCurve() 
{
	// clear flag
	m_bCurve = false;

	// remove plot data so we can set plot style to surface
	m_Graph3D.GetPlots().Item(1).ClearData();

	// reset the plot style to surface since curve plots set the plot style to line
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::Surface);
	UpdateRadioButtons();

	// turn the color map back on since curve plots turn it off
	m_Graph3D.GetPlots().Item(1).SetColorMapStyle(CNiPlot3D::Shaded);

	// Reenable the surface-only plot styles
	m_HiddenLine.EnableWindow(TRUE);
	m_Surface.EnableWindow(TRUE);
	m_SurfaceLine.EnableWindow(TRUE);
	m_SurfaceNormal.EnableWindow(TRUE);
	m_Contour.EnableWindow(TRUE);
	m_SurfaceContour.EnableWindow(TRUE);
}

//////////////////////////////////////////////////////////////////////////////
//
//	Radio Button Handlers
//
//////////////////////////////////////////////////////////////////////////////

void CPlotStylesDlg::OnRadioContour() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::ContourLine);	
}

void CPlotStylesDlg::OnRadioHiddenLine() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::HiddenLine);
}

void CPlotStylesDlg::OnRadioLine() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::Line);
}

void CPlotStylesDlg::OnRadioLinePoint() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::LinePoint);
}

void CPlotStylesDlg::OnRadioPoint() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::Point);
}

void CPlotStylesDlg::OnRadioSurface() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::Surface);
}

void CPlotStylesDlg::OnRadioSurfaceContour() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::SurfaceContour);
}

void CPlotStylesDlg::OnRadioSurfaceLine() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::SurfaceLine);
}

void CPlotStylesDlg::OnRadioSurfaceNormal() 
{
	m_Graph3D.GetPlots().Item(1).SetStyle(CNiPlot3D::SurfaceNormal);
}

