// Region of InterestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Region of Interest.h"
#include "Region of InterestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegionofInterestDlg dialog

CRegionofInterestDlg::CRegionofInterestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegionofInterestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegionofInterestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegionofInterestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegionofInterestDlg)
	DDX_Control(pDX, IDC_RADIO_ROI, m_RadioSelectROI);
	DDX_Control(pDX, IDC_RADIO_ZPR, m_RadioZPR);
	DDX_Control(pDX, IDC_CWGRAPH3D, m_Graph3D1);
	DDX_Control(pDX, IDC_CWGRAPHROI, m_Graph3DROI);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegionofInterestDlg, CDialog)
	//{{AFX_MSG_MAP(CRegionofInterestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO_ROI, OnRadioRoi)
	ON_BN_CLICKED(IDC_RADIO_ZPR, OnRadioZpr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegionofInterestDlg message handlers

CNiReal64Matrix zData(81,81);
long savedStartI, savedStartJ;

BOOL CRegionofInterestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	GraphSourceData();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRegionofInterestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRegionofInterestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CRegionofInterestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CRegionofInterestDlg)
	ON_EVENT(CRegionofInterestDlg, IDC_CWGRAPH3D, 2 /* PlotMouseMove */, OnPlotMouseMoveCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PI2 VTS_PI4 VTS_PI4)
	ON_EVENT(CRegionofInterestDlg, IDC_CWGRAPH3D, 1 /* PlotMouseDown */, OnPlotMouseDownCwgraph3d, VTS_PI2 VTS_PI2 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PI2 VTS_PI4 VTS_PI4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CRegionofInterestDlg::GraphSourceData() 
{
	// Generate data
	for (long i = 0; i < DATASIZE; i++)
		for (long j = 0; j < DATASIZE; j++)
			zData(j,i) = sin(i / 4.0) * cos(j / 4.0) * sin(j / 13.0) * cos(i / 9.0);

	// Plot the data
	m_Graph3D1.Plot3DSimpleSurface(zData);

	// Flatten out plot by increasing z-axis extents
    m_Graph3D1.GetAxes().Item(3).SetMinimum(-1.0);
    m_Graph3D1.GetAxes().Item(3).SetMaximum(5.0);

    // Set track mode to throw plot events
    m_Graph3D1.SetTrackMode(CNiGraph3D::TrackAllEvents);
	m_RadioSelectROI.SetCheck(1);
}

//////////////////////////////////////////////////////////////////////////////
//	Event handlers
//////////////////////////////////////////////////////////////////////////////

void CRegionofInterestDlg::OnPlotMouseMoveCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XData, VARIANT FAR* YData, VARIANT FAR* ZData, short FAR* PlotIndex, long FAR* PointI, long FAR* PointJ) 
{
	// If no button pressed don't do anything
	if (!*Button)
		return;

	// Get the start and end indices and swap if necessary
	long startI = savedStartI;
	long startJ = savedStartJ;
	long endI = *PointI;
	long endJ = *PointJ;
	if (endI < startI)
		Swap(startI, endI);
	if (endJ < startJ)
		Swap(startJ, endJ);

	// Generate the region of interest data
	long sizeI = endI - startI + 1;
	long sizeJ = endJ - startJ + 1;
	CNiReal64Matrix zData2(sizeI,sizeJ);

	for (int i = 0; i < sizeI; i++)
		for (int j = 0; j < sizeJ; j++)
			zData2(i, j) = zData(i + startI, j + startJ);

	// If we don't have a line reset the plot style and colormap style
	m_Graph3DROI.GetPlots().Item(1).ClearData();
	if ((startI != endI) && (startJ != endJ)) 
	{
		m_Graph3DROI.GetPlots().Item(1).SetStyle(CNiPlot3D::Surface);
		m_Graph3DROI.GetPlots().Item(1).SetColorMapStyle(CNiPlot3D::Shaded);
	}

	// Plot the data
	m_Graph3DROI.Plot3DSimpleSurface(zData2);
}

void CRegionofInterestDlg::OnPlotMouseDownCwgraph3d(short FAR* Button, short FAR* Shift, VARIANT FAR* XData, VARIANT FAR* YData, VARIANT FAR* ZData, short FAR* PlotIndex, long FAR* PointI, long FAR* PointJ) 
{
	// Save the start indices
	savedStartI = *PointI;
	savedStartJ = *PointJ;	
}


void CRegionofInterestDlg::Swap(long & _first, long & _second)
{
	long temp = _first;
	_first = _second;
	_second = temp;
}

void CRegionofInterestDlg::OnRadioRoi() 
{
	// Change track mode to allow selecting a region of interest
	m_Graph3D1.SetTrackMode(CNiGraph3D::TrackAllEvents);
}

void CRegionofInterestDlg::OnRadioZpr() 
{
	// Change track mode to allow zooming, panning, and rotating of the left graph
	m_Graph3D1.SetTrackMode(CNiGraph3D::TrackZoomPanRotate);
}

