// Spinning LightDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Spinning Light.h"
#include "Spinning LightDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpinningLightDlg dialog

CSpinningLightDlg::CSpinningLightDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpinningLightDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpinningLightDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSpinningLightDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpinningLightDlg)
	DDX_Control(pDX, IDC_CWGRAPH3D1, m_graph);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSpinningLightDlg, CDialog)
	//{{AFX_MSG_MAP(CSpinningLightDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpinningLightDlg message handlers

BOOL CSpinningLightDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSpinningLightDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSpinningLightDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSpinningLightDlg::OnStart() 
{
    static const int n = 21;
    static const double nd = 20;
	static const double PI = 3.1415926535;

	// Define u to be a sequence from -PI/2 to PI/2
    // Define v to be a sequence from 0 to PI
    double u[n], v[n];
	int i;
    for (i = 0; i < n; i++) 
	{
        u[i] = (i / nd - 0.5) * PI;
        v[i] = (i / nd - 0.5) * 2 * PI;
	}

    // Generate X, Y, and Z matrices
    CNiReal64Matrix x(n, n), y(n, n), z(n, n);
    for (i = 0; i < n; i++)
        for (int j = 0; j < n; j++) 
		{
            x(n-j-1,i) = cos(v[i]) * cos(u[j]);
            y(n-j-1,i) = sin(v[i]) * cos(u[j]);
            z(n-j-1,i) = sin(u[j]);
		}

	// Set up view
    m_graph.SetViewLatitude(55);
    // Set up lighting
    m_graph.SetLighting(TRUE);
    m_graph.GetLights().Item(1).SetEnabled(TRUE);
    m_graph.GetLights().Item(1).SetLatitude(60);

    // Set fill color to medium blue
	CNiColor blue(0x00, 0x00, 0xff);  //The rgb scale in bytes: red=0, green=0 blue=255
    m_graph.GetPlots().Item(1).SetFillColor(blue);

    // Turn off color map
    m_graph.GetPlots().Item(1).SetColorMapStyle(CNiPlot3D::Shaded);

    // Plot Sphere
    m_graph.GetPlots().Item(1).Plot3DParametricSurface(x, y, z);

	// Start timer
	SetTimer(1, 10, NULL);
	
}


void CSpinningLightDlg::OnTimer(UINT nIDEvent) 
{
	// Rotate the light
    CNiLight light = m_graph.GetLights().Item(1);
	light.SetLongitude(light.GetLongitude() + 15);
	light.SetLatitude(light.GetLatitude() + 5);
	CDialog::OnTimer(nIDEvent);

	// Eat spurious WM_TIMER messages
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
}

void CSpinningLightDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	KillTimer(1);		
}
