// TransparencyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Transparency.h"
#include "TransparencyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransparencyDlg dialog

CTransparencyDlg::CTransparencyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTransparencyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTransparencyDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTransparencyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTransparencyDlg)
	DDX_Control(pDX, IDC_CWGRAPH3D, m_graph);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTransparencyDlg, CDialog)
	//{{AFX_MSG_MAP(CTransparencyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransparencyDlg message handlers

BOOL CTransparencyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	GenerateData();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTransparencyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTransparencyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#define DataSize 21
void CTransparencyDlg::GenerateData() 
{

	// Generate data
	double t[DataSize];
	CNiReal64Matrix zData1(DataSize,DataSize);
	CNiReal64Matrix zData2(DataSize,DataSize);
	CNiReal64Matrix zData3(DataSize,DataSize);
	CNiReal64Matrix zData4(DataSize,DataSize);
	long i;
	
	for (i = 0; i < DataSize; i++)
		t[i] = (double)(i - DataSize/2)/(double)(DataSize/2);
	for (i = 0; i < DataSize; i++)
		for (long j = 0; j < DataSize; j++) 
		{
			zData1(static_cast<long>(DataSize-j-1),i) = -sqrt(t[i] * t[i] + t[j] * t[j]);
			zData2(static_cast<long>(DataSize-j-1),i) = -sqrt(t[i] * t[i] + t[j] * t[j]) + 1.0;
			zData3(static_cast<long>(DataSize-j-1),i) = -sqrt(t[i] * t[i] + t[j] * t[j]) + 2.0;
			zData4(static_cast<long>(DataSize-j-1),i) = -sqrt(t[i] * t[i] + t[j] * t[j]) + 3.0;
		}

	//Set the transparency for each plot
	m_graph.GetPlots().Item(1).Transparency=90;	//90% transparent
	m_graph.GetPlots().Item(2).Transparency=70;	
	m_graph.GetPlots().Item(3).Transparency=50;
	m_graph.GetPlots().Item(4).Transparency=30;

	// Plot the data
	m_graph.GetPlots().Item(1).Plot3DSimpleSurface(zData1);
	m_graph.GetPlots().Item(2).Plot3DSimpleSurface(zData2);
	m_graph.GetPlots().Item(3).Plot3DSimpleSurface(zData3);
	m_graph.GetPlots().Item(4).Plot3DSimpleSurface(zData4);
}
